<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="author" content="Your Name" />
    <meta
      name="description"
      content="Robotics Monte Carlo Simulation - GitLab Page"
    />
    <title>Robotics Monte Carlo Simulation</title>

    <script src="https://cdn.tailwindcss.com"></script>
  </head>

  <body class="bg-gray-50 text-gray-900 font-serif">
    <!-- Main Wrapper -->
    <div class="min-h-screen flex flex-col">
      <!-- Header Section -->
      <header class="bg-blue-900 text-white py-12">
        <div class="container mx-auto text-center">
          <h1 class="text-5xl font-extrabold tracking-wide mb-4">
            Monte Carlo Localization
          </h1>
          <p class="text-lg max-w-3xl mx-auto text-gray-300">
            A robotics simulation using Monte Carlo Localization (MCL) to
            estimate the position of a robot with probabilistic methods. Watch
            demos below to see the algorithm in action. For a more in-depth look
            at the algorithm, see a PDF of the report written for the project.
          </p>
        </div>
      </header>

      <!-- Main Content Section -->
      <main class="container mx-auto px-6 py-12 space-y-20">
        <!-- Repo Link Section -->
        <section id="repo-link" class="mb-12">
          <h2 class="text-center text-3xl font-semibold text-blue-900 mb-6">
            Source Code
          </h2>
          <p class="text-lg text-gray-700 max-w-2xl mx-auto">
            The full source code is available here:
            <a
              href="https://gitlab.com/usi_work/semester-2/robotics/robo-slam"
              class="text-blue-600 hover:underline"
              >MCL Source Code</a
            >. The localization algorithm can be found in
            <code class="bg-gray-200 px-1 py-0.5 rounded"
              >robo_slam/robo_localization.py</code
            >.
          </p>
        </section>

        <!-- Demo Explanation Section -->
        <section id="demo-explanation" class="mb-12">
          <h2 class="text-center text-3xl font-semibold text-blue-900 mb-6">
            How It Works
          </h2>
          <p class="text-lg text-gray-700 max-w-2xl mx-auto">
            The simulation uses Monte Carlo Localization (MCL) to estimate the
            robot’s position by maintaining multiple potential locations and
            updating them based on sensor and movement data. In these demos, you
            can see how MCL adapts to various situations like localization
            success, the “kidnapped robot” problem, and failure due to incorrect
            object detection.
          </p>
          <p class="text-lg text-gray-700 max-w-2xl mx-auto mt-4">
            In each video, the left window shows a simulation running in
            <a
              href="https://en.wikipedia.org/wiki/CoppeliaSim"
              class="text-blue-600 hover:underline"
              >Coppelia Sim</a
            >
            in ROS. The robot moves randomly using a basic roomba-like
            algorithm. On the right side, you’ll see the Monte Carlo
            Localization in action. The red dot represents the robot’s actual
            unknown position. The blue dots are possible guesses for where the
            robot could be. The green dot is the algorithm’s best guess for the
            robot’s position.
          </p>
        </section>

        <!-- Demo Videos Section -->
        <section id="demo">
          <h2 class="text-4xl font-semibold text-center text-blue-900 mb-8">
            Demo Videos
          </h2>
          <div class="grid grid-cols-1 lg:grid-cols-2 gap-12">
            <!-- Video 1 -->
            <div class="bg-white">
              <h3 class="mb-4 text-2xl font-bold text-blue-900">
                Localization Success
              </h3>
              <p class="mb-4 text-lg text-gray-700">
                This demo shows how MCL successfully estimates the robot's
                position after some time, honing in on the correct location.
              </p>
              <video class="w-full h-auto object-cover rounded-lg" controls>
                <source src="videos/mcl_localized.mp4" type="video/mp4" />
              </video>
            </div>

            <!-- Video 2 -->
            <div class="bg-white">
              <h3 class="mb-4 text-2xl font-bold text-blue-900">
                Kidnap Localization Success
              </h3>
              <p class="mb-4 text-lg text-gray-700">
                MCL can handle the "Kidnapped Robot Problem," where the robot is
                moved without its knowledge and needs to localize itself.
              </p>
              <video class="w-full h-auto object-cover rounded-lg" controls>
                <source src="videos/kidnap_localization.mp4" type="video/mp4" />
              </video>
            </div>

            <!-- Video 3 -->
            <div class="bg-white rounded-lg overflow-hidden">
              <h3 class="mb-4 text-2xl font-bold text-blue-900 mb-4">
                Failed Object Detection
              </h3>
              <p class="mb-4 text-lg text-gray-700">
                This demo shows MCL failing when an unknown object is added.
                This is because the map is not dynamically generated. We are
                performing only the localizaton portion of SLAM (Simultaneous
                Localizaton and Mapping).
              </p>
              <video class="w-full h-auto rounded-lg object-cover" controls>
                <source src="videos/fail_with_object.mp4" type="video/mp4" />
              </video>
            </div>
          </div>
        </section>

        <!-- Report Section -->
        <section id="paper" class="bg-gray-100 py-12 px-6 rounded-lg">
          <h2 class="text-3xl font-semibold text-center text-blue-900 mb-6">
            Report
          </h2>
          <p class="text-lg text-gray-700 text-center mb-6">
            Dive deeper into the methodology and results of this simulation with
            the detailed report.
          </p>
          <div class="text-center">
            <a
              href="report/main.pdf"
              target="_blank"
              class="inline-block px-8 py-4 bg-blue-900 text-white font-semibold rounded-full hover:bg-blue-700 transition"
            >
              Download Paper (PDF)
            </a>
          </div>
        </section>
      </main>

      <!-- Footer Section -->
      <style>
        @keyframes bounce {
          0% {
            transform: translateY(0);
          }
          50% {
            transform: translateY(-10px);
          }
          100% {
            transform: translateY(0);
          }
        }
        .footer-bounce {
          animation: bounce 1s infinite;
        }
      </style>
      <footer class="bg-blue-900 text-white py-8">
        <div class="text-center">
          <p class="footer-bounce">Thanks for visiting!! 👋</p>
        </div>
      </footer>
    </div>
  </body>
</html>
